package org.eclipse.jdt.internal.compiler.lookup;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.eclipse.jdt.internal.compiler.lookup.LookupEnvironment;
import org.eclipse.jdt.internal.compiler.lookup.ParameterizedMethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.ParameterizedTypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.Substitution;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.TypeVariableBinding;

class null implements Substitution {
  public LookupEnvironment environment() {
    return parameterizedDeclaringClass.environment;
  }
  
  public boolean isRawSubstitution() {
    return (!isStatic && parameterizedDeclaringClass.isRawSubstitution());
  }
  
  public TypeBinding substitute(TypeVariableBinding typeVariable) {
    if (typeVariable.rank < length && TypeBinding.equalsEquals((TypeBinding)originalVariables[typeVariable.rank], (TypeBinding)typeVariable)) {
      TypeVariableBinding typeVariableBinding = substitutedVariables[typeVariable.rank];
      return typeVariable.hasTypeAnnotations() ? environment().createAnnotatedType((TypeBinding)typeVariableBinding, typeVariable.getTypeAnnotations()) : (TypeBinding)typeVariableBinding;
    } 
    if (!isStatic)
      return parameterizedDeclaringClass.substitute(typeVariable); 
    return (TypeBinding)typeVariable;
  }
}
